<template>
  <div>
    <!-- Project Name -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="ProjectName"
      :label="$t('form.project.projectNameLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <!-- number of characters -->
      <template #hint>
        {{ v$.projectForManipulation.name.$model.length }} /
        {{ v$.projectForManipulation.name.maxLength.$params.max }}
      </template>
      <b-form-input
        id="ProjectName"
        v-model="v$.projectForManipulation.name.$model"
        :state="
          v$.projectForManipulation.name.$dirty
            ? !v$.projectForManipulation.name.$error
            : null
        "
        :placeholder="$t('form.project.projectName')"
        :maxlength="v$.projectForManipulation.name.maxLength.$params.max"
        required
        :disabled="disabled"
        @update:modelValue="translateProjectNameToDisplayName"
      />
      <div class="invalid-tooltip">
        {{
          $t("form.project.projectNameHelp", {
            maxLength: v$.projectForManipulation.name.maxLength.$params.max,
          })
        }}
      </div>
    </CoscineFormGroup>

    <!-- Display Name -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="DisplayName"
      :label="$t('form.project.displayNameLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <!-- number of characters -->
      <template #hint>
        {{ projectForManipulation.displayName?.length ?? 0 }} /
        {{ v$.projectForManipulation.displayName.maxLength.$params.max }}
      </template>
      <b-form-input
        id="DisplayName"
        v-model="v$.projectForManipulation.displayName.$model"
        :state="
          v$.projectForManipulation.displayName.$dirty
            ? !v$.projectForManipulation.displayName.$error
            : null
        "
        :placeholder="$t('form.project.displayName')"
        :maxlength="v$.projectForManipulation.displayName.maxLength.$params.max"
        required
        :disabled="disabled"
        @update:modelValue="isLockedDisplayName = true"
      />
      <div class="invalid-tooltip">
        {{
          $t("form.project.displayNameHelp", {
            maxLength:
              v$.projectForManipulation.displayName.maxLength.$params.max,
          })
        }}
      </div>
    </CoscineFormGroup>

    <!-- Project Description -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="Description"
      :label="$t('form.project.projectDescriptionLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <!-- number of characters -->
      <template #hint>
        {{ v$.projectForManipulation.description.$model.length }} /
        {{ v$.projectForManipulation.description.maxLength.$params.max }}
      </template>
      <b-form-textarea
        id="Description"
        v-model="v$.projectForManipulation.description.$model"
        :state="
          v$.projectForManipulation.description.$dirty
            ? !v$.projectForManipulation.description.$error
            : null
        "
        :placeholder="$t('form.project.projectDescription')"
        :maxlength="v$.projectForManipulation.description.maxLength.$params.max"
        required
        :disabled="disabled"
      />
      <div class="invalid-tooltip">
        {{
          $t("form.project.projectDescriptionHelp", {
            maxLength:
              v$.projectForManipulation.description.maxLength.$params.max,
          })
        }}
      </div>
    </CoscineFormGroup>
  </div>
</template>

<script lang="ts" setup>
import { required, maxLength } from "@vuelidate/validators";
import { useVuelidate, type BaseValidation } from "@vuelidate/core";
import type {
  ProjectForCreationDto,
  ProjectForUpdateDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

const projectForManipulation = defineModel<
  ProjectForCreationDto | ProjectForUpdateDto
>({ required: true });

defineProps({
  disabled: {
    default: false,
    type: Boolean,
  },
  isLoading: {
    default: false,
    type: Boolean,
  },
});

const emit = defineEmits<{
  validation: [_: BaseValidation<typeof projectForManipulation.value>];
}>();

/*
  Definition of the validation rules and initial state
  will enable proper typings in the code
*/
const state = reactive({
  projectForManipulation: projectForManipulation,
});
const rules = {
  projectForManipulation: {
    name: { required, maxLength: maxLength(200) },
    displayName: { required, maxLength: maxLength(25) },
    description: { required, maxLength: maxLength(10000) },
  },
};
const v$ = useVuelidate(rules, state);

const isLockedDisplayName = ref(false);

watch(
  () => projectForManipulation.value,
  () => {
    emit("validation", v$.value.projectForManipulation);
  },
  { deep: true },
);

const translateProjectNameToDisplayName = () => {
  if (!isLockedDisplayName.value && projectForManipulation.value.name) {
    projectForManipulation.value.displayName =
      projectForManipulation.value.name.substring(0, 25);
    v$.value.projectForManipulation.displayName?.$touch();
  }
};
</script>
